#!/bin/sh

progname=`echo $0 | sed 's,^.*/,,'`
suffix_list=".tar.gz .tar.Z .tgz .taZ .tar .zip .Lzh"
suffix=.tgz
baseremove=no
unset -v basefiletar basedir basefile difffile

if [ -n $TMPDIR ]; then
  tmpdir=$TMPDIR
else
  tmpdir=/tmp
fi

# update GNU bash
basefiletar=`pwd`/bashp1.tar
basedir=bash-1.14.3
basefile=`pwd`/${basedir}.tar.gz
if [ -f $basefiletar -a ! -f $basefile ]; then
  echo "extracting $basefile in $basefiletar"
  tar xf $basefiletar `echo $basefile | sed -e 's,^.*/,,'`
  baseremove=yes
fi
difffiles="`pwd`/bashp*${suffix}"

# suppress basefile
difffiles=`echo $difffiles | sed "s,${basefile},," | sort`

if [ -z "$difffiles" ]; then
  echo "${progname}: t@C͂܂" 1>&2
  exit 0
fi

if [ ! -f $basefile ]; then
  if [ ! -f $basefiletar ]; then
    echo "${progname}: t@C '$basefiletar' ܂" 1>&2
  else
    echo "${progname}: t@C '$basefile' ܂" 1>&2
  fi
  exit 1
fi

rm -rf $tmpdir/update
mkdir $tmpdir/update

echo "extracting in $basefile"
(cd $tmpdir/update; \
 gzcat $basefile | tar xf - $basedir/bin/bash $basedir/README.\*)
mv $tmpdir/update${basedir+/${basedir}}/README.* .
mv $tmpdir/update${basedir+/${basedir}/bin}/bash $tmpdir/update

for file in $difffiles
do
  echo "patching in $file"
  (cd $tmpdir/update; \
   gzcat $file | tar xf - bash.bfd README\*; \
   bup -NA bash.bfd >& /dev/null; rm -f bash.bfd)
  mv $tmpdir/update/README* .
done

echo "patched."
mv $tmpdir/update/bash .
chmod 777 bash

echo "cleaning temporary"
rm -rf $tmpdir/update

if [ $baseremove = yes ]; then
  echo "remove $basefile"
  rm -rf $basefile
fi

exit 0
